<a href="https://www.bilibili.com/video/BV1d4411c76P" target="_blank">视频地址</a>


新建 docker/nginx.conf
```sh
server{
      lister 80;
      
      location /{
        root /usr/share/ngin/html;
        index index.html;      
      }
}
```

新建 docker/Dockerfile

```sh
FROM nginx:alpine

COPY ./nginx.conf /etc/nginx/conf.d/default.conf #宿主机nginx.conf 覆盖掉 容器里的default.conf
COPY ./dest /usr/share/nginx/html #把当前目录里的dest 文件夹复制到容器里的html目录里
```

新建 docker/build.sh 打包vue

```sh
npm run build # 打包vue
cp -r ../dist ./  #复制dist目录的docker目录里
docker build -t giligili:v1.0.0  # 基于当前目录里的Dockerfile打包vue项目为容器
docker push giligili:v1.0.0 # 推送容器
```

在docker目录里手动启动nginx容器
```sh
docker run -p 9999:80 nginx:alpine
docker run -it nginx:alpine sh
ls -als
```

在项目docker目录手动打包vue并打包为本地容器
```sh
npm run build #  打包vue
docker build -t giligili:v0.0.1 ./ # 基于当前目录里的Dockerfile打包vue项目为容器
```
![](https://img2020.cnblogs.com/blog/1441611/202008/1441611-20200823152208280-223427162.png)

把dist目录复制到docker目录里

cp -r ./dist docker

运行容器

`docker run -p 9999:80 giligili:v0.0.0.1`

已经可以正常访问了

![](https://img2020.cnblogs.com/blog/1441611/202008/1441611-20200823152604269-1429900711.png)


## 建立自己的阿里云镜像仓库

登陆->控制台->产品与服务->搜索镜像->镜像容器服务

![](https://img2020.cnblogs.com/blog/1441611/202008/1441611-20200823153611020-1236188298.png)

创建命名空间

![](https://img2020.cnblogs.com/blog/1441611/202008/1441611-20200823154100973-703073291.png)
![](https://img2020.cnblogs.com/blog/1441611/202008/1441611-20200823154209261-1098469052.png)

创建镜像仓库

![](https://img2020.cnblogs.com/blog/1441611/202008/1441611-20200823154446206-957007944.png)
![](https://img2020.cnblogs.com/blog/1441611/202008/1441611-20200823154520765-1208979560.png)

设置docker仓库的登陆密码
![](https://img2020.cnblogs.com/blog/1441611/202008/1441611-20200823155040692-36232888.png)

进入管理仓库
![](https://img2020.cnblogs.com/blog/1441611/202008/1441611-20200823154654807-1371176622.png)


重新编写本地的 build.sh

获取阿里云仓库地址

![](https://img2020.cnblogs.com/blog/1441611/202008/1441611-20200823161514967-1563843972.png)

```sh
1. 登录阿里云Docker Registry


# 以自己实际建立的地址为准
[root@VM-24-16-opencloudos docker-lnmp]# sudo docker login --username=hi31110179@aliyun.com registry.cn-beijing.aliyuncs.com
Password:  #输入密码
WARNING! Your password will be stored unencrypted in /root/.docker/config.json.
Configure a credential helper to remove this warning. See
https://docs.docker.com/engine/reference/commandline/login/#credentials-store

Login Succeeded

用于登录的用户名为阿里云账号全名，密码为开通服务时设置的密码。

您可以在访问凭证页面修改凭证密码。

2. 从Registry中拉取镜像

$ docker pull registry.cn-beijing.aliyuncs.com/haimait/haimait:[镜像版本号]

3. 将镜像推送到Registry

$ docker login --username=hi311*****@aliyun.com registry.cn-beijing.aliyuncs.com

$ docker tag [ImageId] registry.cn-beijing.aliyuncs.com/haimait/haimait:[镜像版本号] # 打包镜像
如 重命名php:7.3.8-fpm-alpine-extend 为 registry.cn-beijing.aliyuncs.com/haimait/php:7.3.8-fpm-alpine-extend
$ docker tag php:7.3.8-fpm-alpine-extend registry.cn-beijing.aliyuncs.com/haimait/php:7.3.8-fpm-alpine-extend

$ docker push registry.cn-beijing.aliyuncs.com/haimait/haimait:[镜像版本号]
如：$ docker push registry.cn-beijing.aliyuncs.com/haimait/php:7.3.8-fpm-alpine-extend

请根据实际镜像信息替换示例中的[ImageId]和[镜像版本号]参数。
4. 选择合适的镜像仓库地址

从ECS推送镜像时，可以选择使用镜像仓库内网地址。推送速度将得到提升并且将不会损耗您的公网流量。

如果您使用的机器位于VPC网络，请使用 registry-vpc.cn-beijing.aliyuncs.com 作为Registry的域名登录。
5. 示例

使用"docker tag"命令重命名镜像，并将它通过专有网络地址推送至Registry。

$ docker images
REPOSITORY                                                         TAG                 IMAGE ID            CREATED             VIRTUAL SIZE
registry.aliyuncs.com/acs/agent                                    0.7-dfb6816         37bb9c63c8b2        7 days ago          37.89 MB
$ docker tag registry.aliyuncs.com/acs/agent:0.7-dfb6816 registry.cn-beijing.aliyuncs.com/haimait/agent:0.7-dfb6816

使用 "docker push" 命令将该镜像推送至远程。

$ docker push registry.cn-beijing.aliyuncs.com/haimait/agent:0.7-dfb6816
```


```sh
npm run build # 打包vue
cp -r ../dist ./  #复制dist目录的docker目录里
docker build -t registry.cn-beijing.aliyuncs.com/haimait/haimablog:v1.0.0 ./  # 基于当前目录里的Dockerfile打包vue项目为容器
docker push registry.cn-beijing.aliyuncs.com/haimait/haimait:v1.0.0 # 推送容器阿里云仓库
```

登陆阿里云docker仓库

![](https://img2020.cnblogs.com/blog/1441611/202008/1441611-20200823155926331-424670540.png)

## 手动打包上传到阿里云docker仓库

1.基于当前目录里的Dockerfile打包vue项目为容器
![](https://img2020.cnblogs.com/blog/1441611/202008/1441611-20200823155735344-1916152702.png)

2.推送容器阿里云仓库
![](https://img2020.cnblogs.com/blog/1441611/202008/1441611-20200823160100519-522724847.png)

3.看一下阿里云仓库里已经有了
![](https://img2020.cnblogs.com/blog/1441611/202008/1441611-20200823160137921-1547449546.png)


4.用build.sh自动打包上传到阿里云仓库
![](https://img2020.cnblogs.com/blog/1441611/202008/1441611-20200823160508780-670279656.png)

## windows系统的电脑连接服务器
安装 putty 或者 winscp 或者 xshell
或者安装win10 wsl 这是在windows里安装一个linux 

登陆ssh
![](https://img2020.cnblogs.com/blog/1441611/202008/1441611-20200823163026868-1593326520.png)

更新ubuntu系统源
`soud apt-get update`

在服务器上安装docker


## go的服务

go的Dockerfile文件

![](https://img2020.cnblogs.com/blog/1441611/202008/1441611-20200823163530545-1762132073.png)

打包镜像
![](https://img2020.cnblogs.com/blog/1441611/202008/1441611-20200823164150110-605860018.png)

推送镜像
![](https://img2020.cnblogs.com/blog/1441611/202008/1441611-20200823164234000-1313486963.png)


容器操作宿主机的容器，安装运行下面的容器
![](https://img2020.cnblogs.com/blog/1441611/202008/1441611-20200823164524539-1722780736.png)

![](https://img2020.cnblogs.com/blog/1441611/202008/1441611-20200823164405119-1349475068.png)

![](https://img2020.cnblogs.com/blog/1441611/202008/1441611-20200823164613625-1507094786.png)

![](https://img2020.cnblogs.com/blog/1441611/202008/1441611-20200823164624341-2022725087.png)

![](https://img2020.cnblogs.com/blog/1441611/202008/1441611-20200823164704410-458082517.png)


docker学习地址
![](https://img2020.cnblogs.com/blog/1441611/202008/1441611-20200823164745849-1716921794.png)