[TOC]


## image镜像管理 拉取/查看/历史/删除
```shell
docker pull centos/mysql-57-centos7
docker pull 镜像名称 //例:docker pull centos:7
docker save -o 包名.tar 本地的镜像地址 //打包镜像为tar包
docker load -i /home/包名.tar // 从本地tar包导入镜像
docker image ls //列出本地的镜像
docker images //列出本地的镜像
docker history 97b46f5bffb8 //看一下镜像的详情 97b46f5bffb8是IMAGE ID值 
docker rmi image镜像名字/IMAGE ID //删除本地image镜像 (注意有运行中的容器是不能删除的)
docker rmi `docker images -q` //删除所有镜像
docker image prune -a //删除无用镜像（需要收到输入y）
docker image prune -a -f //强制删除镜像
docker rm `docker ps -a | grep Exited | awk '{print $1}'` //删除异常停止的docker容器
docker rmi -f  `docker images | grep '<none>' | awk '{print $3}'`  // 删除名称或标签为none的镜像
docker tag <REPOSITORY>:<TAG> <NEW_REPOSITORY>:<TAG> // 修改本地镜像的仓库名称
docker tag <REPOSITORY>:<TAG> <REPOSITORY>:<NEW_TAG> //修改本地镜像的标签名称

# 基于运行的容器,再创建一个image镜像
docker commit sleepy_ride wanghaima/centos-hbb　//基于sleepy_ride创建新的镜像 sleepy_ride是镜像的NAMES值　也可以用CONTAINER ID
docker commit CONTAINER_ID 127.0.0.1:9091/512/f-search/centos-hbb:latest　//基于CONTAINER_ID创建新的镜像 CONTAINER_ID是镜像的NAMES值　,latest是版本号
```

## 容器操作
### 看日志
```shell
docker logs -f 容器id/容器名称
docker logs -f 容器id/容器名称 --tail 100   #滚动显示最最后100行日志
```

### 进容器
```shell
docker exec -it 容器id/容器名称 /bin/bash
docker exec -it 容器id/容器名称 /bin/sh
```

## 宿主机 和 容器 互传文件

```shell
# 文件的拷贝
docker cp #停止或者运行中的容器都可以用cp互传文件
## 从宿主机复制文件到容器里
docker cp 宿主机的文件或者目录 容器:宿主机的文件或者目录
docker cp a.txt mycentos:/usr/local
## 从容器里复制文件到宿主机
docker cp 容器:宿主机的文件或者目录 宿主机的文件或者目录 
docker cp mycentos:/usr/local/a.txt a.txt2
docker cp b42e5c9f385a:/usr/share/nginx/html ./html # html为文件夹
```

## 查询容器网络

```shell
docker network -h
docker network create 网络名称 # 创建网络
docker network ls  #查询所有的网络
docker netspace 容器名称  # 查询容器详情
```