[TOC]

## 环境
- linux centos 7.6

## 安装docker
```sh
# 移除以前docker相关包
sudo yum remove docker \
                  docker-client \
                  docker-client-latest \
                  docker-common \
                  docker-latest \
                  docker-latest-logrotate \
                  docker-logrotate \
                  docker-engine

# 安装yum工具包
sudo yum install -y yum-utils

#配置docker的yum地址
sudo yum-config-manager \
--add-repo \
http://mirrors.aliyun.com/docker-ce/linux/centos/docker-ce.repo

#更新源
sudo yum makecache fast

# 安装最新版本
yum -y install docker-ce docker-ce-cli containerd.io

# 或者安装指定版本

1. 查看版本
yum list docker-ce --showduplicates | sort -r
yum list docker-ce-cli --showduplicates | sort -r
yum list containerd.io --showduplicates | sort -r

2. 指定版本安装
sudo yum install -y docker-ce-24.0.5 docker-ce-cli-24.0.5 containerd.io-1.6.9

# 启动&开机启动docker
systemctl enable docker --now

# docker加速配置
sudo mkdir -p /etc/docker

sudo tee /etc/docker/daemon.json <<-'EOF'
{
  "registry-mirrors":["http://74f21445.m.daocloud.io","https://registry.docker-cn.com","http://hub-mirror.c.163.com","https://docker.mirrors.ustc.edu.cn"],
  "insecure-registries": ["192.168.2.103:8082","harbor.top","midddle"],
  "exec-opts": ["native.cgroupdriver=systemd"],
  "log-driver": "json-file",
  "log-opts": {"max-size": "100m","max-file":"3"},
  "storage-driver": "overlay2"
}
EOF

sudo systemctl daemon-reload
sudo systemctl restart docker
systemctl status docker
docker info

[root@master ~]# docker -v
Docker version 24.0.5, build ced0996
```


## 解决 docker: Error response from daemon: Get “https://registry-1.docker.io/v2/“: net/http:

编辑Docker的配置文件 /etc/docker/daemon.json，添加或修改如下内容，以使用国内的镜像加速器：
修改为下面的源

```json
{
    "runtimes": {
        "nvidia": {
            "args": [],
            "path": "nvidia-container-runtime"
        }
    },
    "registry-mirrors": [
        "https://docker.registry.cyou",
        "https://docker-cf.registry.cyou",
        "https://dockercf.jsdelivr.fyi",
        "https://docker.jsdelivr.fyi",
        "https://dockertest.jsdelivr.fyi",
        "https://mirror.aliyuncs.com",
        "https://dockerproxy.com",
        "https://mirror.baidubce.com",
        "https://docker.m.daocloud.io",
        "https://docker.nju.edu.cn",
        "https://docker.mirrors.sjtug.sjtu.edu.cn",
        "https://docker.mirrors.ustc.edu.cn",
        "https://mirror.iscas.ac.cn",
        "https://docker.rainbond.cc"
    ]
}
```

参考文档
https://cloud.tencent.com/developer/article/2486234

## 安装docker命令补全工具

`yum install -y bash-completion`

注意:必须要退出终端，重新登录一次才能生效。
输入命令按 `Tab` 键补全