[TOC]

## 修改 `configMap`

### 命令方式修改 `configMap`
以下三种写法都可以修改 `configMap`
修改完保存后，就会自动生效

```shell
# 修改 kubectl edit configMap/core-api-config
# 修改 kubectl edit configmap/core-api-config
# 修改 kubectl edit cm/core-api-config
```


## core-api-configMap.yml
```yaml
apiVersion: v1
kind: ConfigMap
metadata:
  name: core-api-config   # 挂载配置文件 ConfigMap.yaml服务里name和core-api-config挂载到容器volumes下configMap.name绑定
data:
  settings.core-api.k8s.yml: |
    settings:
      application:
        # dev开发环境 test测试环境 prod线上环境
        mode: prod
        # 服务器ip，默认使用 0.0.0.0
        host: 0.0.0.0
        # 服务名称
        name: core_api
        # 端口号
        port: 8081 # 服务端口号
        readtimeout: 1
        writertimeout: 2
        # 数据权限功能开关
        enabledp: true
      logger:
        # 日志存放路径
        path: temp/logs
        # 控制台日志 true false
        stdout: true
        # 日志等级 debug, info ,warning, error, fatal
        level: debug
        # 业务日志开关
        enabledbus: true
        # 请求日志开关
        enabledreq: true
        # 数据库控制台日志开关
        enabledbconsole: false
        # 数据库日志开关 dev模式，将自动开启
        enableddb: true
        # 自动任务日志开关 dev模式，将自动开启
        enabledjob: true
      jwt:
        # token 密钥，生产环境时及的修改
        secret: ff.so
        # token 过期时间 单位：秒
        timeout: 36000
      database:
        # 数据库类型 mysql，sqlite3， postgres
        driver: mysql
        # 数据库连接字符串 mysql 缺省信息 charset=utf8&parseTime=True&loc=Local&timeout=1000ms
        source: root:123456@tcp(192.168.0.1:3306)/core_api?charset=utf8&parseTime=True&loc=Local&timeout=5000ms
        ConnMaxIdleTime:   # 可不填写 空闲连接最大存活时间
        ConnMaxLifetime:   # 可不填写 连接最大存活时间
        MaxIdleConns: 20   # 最大空闲连接数，默认不配置，是2个最大空闲连接
        MaxOpenConns: 100  # 最大连接数，默认不配置，是不限制最大连接数

```